package be.ac.ulb.code.wit.service;

import javax.jws.WebService;

import be.ac.ulb.code.wit.contacts.Contact;

@WebService
public class ContactServiceImpl implements ContactService {
	@Override
	public Contact createContact(String email) {
		Contact c = new Contact(email);
        c.save();
        return c;
	}

	@Override
	public Contact getContact(String email) throws NoSuchContactException {
        Contact result = Contact.FindByEmail(email);
        if (result == null) throw new NoSuchContactException("No contact for " + email);
		return result;
	}

	@Override
	public void removeContact(String email) throws NoSuchContactException {
        Contact contact = Contact.FindByEmail(email);
        if (contact == null) throw new NoSuchContactException("No contact for " + email);
        contact.remove();
	}

	@Override
	public void changeEmail(String oldEmail, String newEmail) throws NoSuchContactException {
        Contact result = Contact.FindByEmail(oldEmail);
        if (result == null) throw new NoSuchContactException("No contact for " + oldEmail);

        Contact newContact = new Contact(newEmail);
        newContact.groups.addAll(result.groups);

        result.remove();
        newContact.save();
	}

	@Override
	public Contact[] getContacts() {
        return Contact.FindAll().toArray(new Contact[0]);
	}
}
